#include <iostream>
#include "Data.h"
#include "TravelCompany.h"

void first_test() {
	std::cout << "---------------------------" << " Data Test " << "---------------------------" << std::endl;
	bool b = true;
	while (b) {
		std::cout << "1: createData\n2: createDataContainer\n3: loadData\n4: streamloadData" << std::endl;
		std::cout << "5: modify\n6: modify_iterator\n7: modify_for_each\n8: outputResult\n9: outputResultContainer" << std::endl;
		std::cout << "10: clear screen\n11: exit" << std::endl;
		int code;
		std::cin >> code;
		Data<int> d;
		auto print = [](std::vector<int> cont) {
			for (auto i = cont.begin(); i != cont.end(); ++i) {
				std::cout << *i << " ";
			}
		};
		try {
			switch (code) {
				case 1: createData("1f.txt"); break;
				case 2: createDataContainer("1f.txt"); break;
				case 3: print(d.loadData("1f.txt")); break;
				case 4: print(d.streamloadData("1f.txt")); break;
				case 5: d.modify(); break;
				case 6: d.modify_iterator(); break;
				case 7: d.modify_for_each(); break;
				case 8: d.outputResult("2f.txt"); break;
				case 9: d.outputResultContainer("2f.txt"); break;
				case 10: system("cls"); break;
				case 11: b = false; break;
				default: std::cout << "Entered code is wrong!" << std::endl;
			}
		}
		catch (std::exception& error) {
			std::cerr << error.what() << std::endl;
		}
	}
}

void second_test() {
	std::cout << std::endl << "---------------------------" << " TravelCompany Test " << "---------------------------" << std::endl;
	bool b = true;
	while (b) {
		std::cout << "1: create_file\n2: add\n3: delete_data\n4: replacement" << std::endl;
		std::cout << "5: convert_to_txt\n6: clear screen\n7: exit" << std::endl;
		int code;
		std::cin >> code;
		std::ofstream file_write("1s.bin");
		std::ifstream file_read("1s.bin");
		std::ofstream file2_write("2s.bin");
		TravelCompany data; 
		std::cin >> data;
		try {
			switch (code) {
				case 1: TravelCompany::create_file(file_write); break;
				case 2: data.add(file_write); break;
				case 3: data.delete_data(file2_write, file_read); break;
				case 4: data.replacement(file2_write, file_read, data); break;
				case 5: TravelCompany::convert_to_txt("2s"); break;
				case 6: system("cls"); break;
				case 7: b = false; break;
				default: std::cout << "Entered code is wrong!" << std::endl;
			}
		}
		catch (std::exception& error) {
			std::cerr << error.what() << std::endl;
		}
	}
}

int main() {
	first_test();
	system("pause");
	second_test();
	system("pause");	
	return 0;
}