#include "TravelCompany.h"

std::ostream& operator << (std::ostream& out, const TravelCompany& data) {
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		out << i->tour_name << " " <<
			i->surname << " " <<
			i->price << " " <<
			i->days << " " <<
			i->moving_cost << " " <<
			i->exchange_rate << " " <<
			i->amount << " " <<
			i->travel_cost << " " << std::endl;
	}
	return out;
}

std::istream& operator >> (std::istream& in, TravelCompany& data) {
	data = TravelCompany();
	while (true) {
		TravelCompany::Data d;
		in >> d.tour_name;
		in >> d.surname;
		if (d.tour_name == "\\0" && d.surname == "\\0" || d == TravelCompany::Data()) {
			data.cont.insert(TravelCompany::Data());
			break;
		}
		in >> d.price;
		in >> d.days;
		in >> d.moving_cost;
		in >> d.exchange_rate;
		in >> d.amount;
		in >> d.travel_cost;
		data.cont.insert(d);
	}
	return in;
}

bool TravelCompany::operator == (const TravelCompany& data) {
	if (cont.size() != data.cont.size())
		return false;
	auto i = cont.begin();
	auto j = data.cont.begin();
	while (i != cont.end() && j != data.cont.end()) {
		if (const_cast<TravelCompany::Data&>(*i) != const_cast<TravelCompany::Data&>(*j))
			return false;
		++i;
		++j;
	}
	return true;
}

void TravelCompany::add(std::ofstream& file) {
	for (auto i = cont.begin(); i != cont.end(); ++i) {
		file.write(i->tour_name.c_str(), strlen(i->tour_name.c_str()));
		file.write(i->surname.c_str(), strlen(i->surname.c_str()));
		file.write(reinterpret_cast<const char*>(&i->price), sizeof(i->price));
		file.write(reinterpret_cast<const char*>(&i->days), sizeof(i->days));
		file.write(reinterpret_cast<const char*>(&i->moving_cost), sizeof(i->moving_cost));
		file.write(reinterpret_cast<const char*>(&i->exchange_rate), sizeof(i->exchange_rate));
		file.write(reinterpret_cast<const char*>(&i->amount), sizeof(i->amount));
		file.write(reinterpret_cast<const char*>(&i->travel_cost), sizeof(i->travel_cost));
	}
	//file << *this;
}

void TravelCompany::read(std::ifstream& file) {
	while (!file.eof()) {
		TravelCompany::Data d;
		file.read(const_cast<char*>(d.tour_name.c_str()), sizeof(d.tour_name));
		file.read(const_cast<char*>(d.surname.c_str()), sizeof(d.surname));
		file.read(reinterpret_cast<char*>(&d.price), sizeof(d.price));
		file.read(reinterpret_cast<char*>(&d.days), sizeof(d.days));
		file.read(reinterpret_cast<char*>(&d.moving_cost), sizeof(d.moving_cost));
		file.read(reinterpret_cast<char*>(&d.exchange_rate), sizeof(d.exchange_rate));
		file.read(reinterpret_cast<char*>(&d.amount), sizeof(d.amount));
		file.read(reinterpret_cast<char*>(&d.travel_cost), sizeof(d.travel_cost));
		this->cont.insert(d);
	}
	// file >> *this;
}

void TravelCompany::create_file(std::ofstream& file) {
	TravelCompany data;
	std::cin >> data;
	data.add(file);
}

void TravelCompany::delete_data(std::ofstream& file_write, std::ifstream& file_read) {
	TravelCompany data;
	data.read(file_read);
	bool b = true;
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		if (b && !const_cast<Data&>(*i).in(this->cont))
			data.add(file_write);
		else
			b = false;
		if (!b)
			data.add(file_write);
	}
}

void TravelCompany::replacement(std::ofstream& file_write, std::ifstream& file_read, TravelCompany& data) {
	this->delete_data(file_write, file_read);
	data.add(file_write);
}

void TravelCompany::convert_to_txt(const std::string& filepath) {
	TravelCompany data;
	std::ifstream file_read(filepath + ".bin");
	data.read(file_read);
	if (rename((filepath + ".bin").c_str(), (filepath + ".txt").c_str()) != 0)
		throw FileException(2);
	std::ofstream file_write(filepath + ".txt");
	file_write << data;
}
